;
; LOD Player Version 2
;
; 1Cf2
; 1D8f
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

OFF	= $47
	
; COMMAND BYTES

END_MARK	= $FE
SET_VOLTAB	= $FF
SET_ARP		= $FD
CLICK		= $FC
VOL_UP		= $FB
SETINS		= $F0
SETLEN		= $50

; Constants
base_note = 0 ; shift to C0
C0	= base_note + 0
Ci0	= base_note + 1
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

;-----
          
	;ALIGN 256
PLAYER_INIT
	;         
	; *** Freq init
	;
	ldx #(Channel1) & 255
	ldy #(Channel1) >> 8
	stx PCH1_LO
	sty PCH1_HI
	;
	ldx #(Channel2) & 255
	ldy #(Channel2) >> 8
	stx PCH2_LO
	sty PCH2_HI
	;
	ldx #(Channel3) & 255
	ldy #(Channel3) >> 8
	stx PCH3_LO
	sty PCH3_HI
	;
	ldx #$FF
	stx VOLTAB_CNT
	inx       
	stx NOTE1
	stx NOTE2
	stx NOTE3
	jsr res
	inx
	stx NOTELEN1
	stx NOTELEN2
	stx NOTELEN3
	jsr res
	inx		; x=2
	jsr res
	;
	lda #9*0
	sta VOLUME
	;
	rts

res	ldy #$00
	db $2C
	
advance	ldy PCH1,x
	;      
	lda PCH1_LO,x
	sta PCH_TEMP
	lda PCH1_HI,x
	sta PCH_TEMP+1
	;
	lda (PCH_TEMP),y	; LO byte
	sta CH1_LO,x
	iny
	lda (PCH_TEMP),y	; HI byte
	beq res
	sta CH1_HI,x
	iny
	sty PCH1,x
	rts
	
	;
	;##################
	;
	
PLAYER
;	lda $FF19
;	eor #$55
;	sta $FF19
;	jsr PLAYER1
;	lda $FF19
;	eor #$55
;	sta $FF19
;	rts
;
;PLAYER1
	ldx #$02
	;
channel_loop
	inc NOTE1,x
	;
	lda NOTE1,x
	cmp NOTELEN1,x
	beq next_note
	jmp channel_loop_end
	;
next_note 
	lda CH1_LO,x
	sta CH_TEMP
	lda CH1_HI,x
	sta CH_TEMP+1
	;
	ldy #$00
	sty NOTE1,x		; reset note counter
	;   
	lda (CH_TEMP),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	bne pl_10
	;
	jsr advance
	bne next_note		; should never be zero
	;
pl_10	cmp #SET_VOLTAB
	bne pl_12
	;
	sta VOLTAB_CNT
	;
	lda (CH_TEMP),y		; get lo byte
	iny
	sta VOL_TAB+1
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_12	cmp #SET_ARP		; instrument change?
	bne pl_13
	;
	lda (CH_TEMP),y		; get arpeggio byte
	and #$0F
	sta arpeggio+1
	;
	lda (CH_TEMP),y		; get same byte again
	lsr a
	lsr a
	lsr a
	lsr a
	sta arpeggio+2
	beq arp2v
	;
	lda #$06
	db $2C
arp2v	lda #$04
	sta arplen+1
	;
	iny
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_13	cmp #CLICK
	bne pl_14
	;
	lda $FF11
	ora #$80
	sta $FF11
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_14	cmp #VOL_UP
	bne pl_15
	;
	lda VOLUME
	beq vol_at_max
	;
	sec
	sbc #$09
	sta VOLUME
	;
vol_at_max
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_15	cmp #$FA
	bne pl_11
	;
	dec $FF19
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_11	cmp #SETINS		; instrument change?
	bcc pl_01
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE1,x   	; store instrument type
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_01	cmp #SETLEN		; set note length?
	bcc pl_02
	;
	;SEC			; we know carry is always set
	sbc #SETLEN
	sta NOTELEN1,x
	;
	lda (CH_TEMP),y
	iny
	;
pl_02	; - store note!
	;
	sta TONE1,x
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH1_LO,x
	sta CH1_LO,x
	bcc noi_1
	inc CH1_HI,x
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel_loop_end
	dex
	bmi pl_50
	jmp channel_loop
	;    
pl_50	
	;
	; --- SOUND PROCESSING
	;
PLAYER_SOUND
	lda #$20
	sta NOISE
	;
	ldx #$02		; channel 3
	jsr sound
	;
	cmp #$FE
	bne do_ch2
	;
	ldx #$01		; channel 2
	jsr sound
	;
do_ch2	sta F1LO_store+1
	sty F1HI_x+1
	;
	lda F1HI
	and #$FC
F1HI_x	ora #$00
	sta F1HI_store+1
	;
	ldx #$00		; channel 1
	jsr sound
	sta F2LO
	sty F2HI
	;
F1LO_store
	lda #$00
	sta F1LO
F1HI_store
	lda #$00
	sta F1HI
	;
	; ---
	;
	ldy VOLTAB_CNT
	iny
res_v	
VOL_TAB	lda vol_default,y
	bpl noi_v		; check for $FF
	ldy #$00		; reached, so warp
	beq res_v
noi_v	sty VOLTAB_CNT
	clc
	adc VOLUME
	tay
	lda volume_map,y
	ora NOISE
	;
	ldy F1LO
	cpy #$FE
	bne setvol		; not silent
	ldy F2LO
	cpy #$FE
	beq sil			; silent: skip setting $FF11 to avoid clicks
	;
setvol	sta $FF11		; self-mod
	;
sil	rts     
	;
inst_table
	dw normal, bassdrum, snare, blipp, arp, vib
	;
sound	lda TONE1,x
	cmp #OFF
	beq lookup
	;
	lda INS_TYPE1,x
	asl a
	tay
	lda inst_table,y
	sta inst_jump+1
	lda inst_table+1,y
	sta inst_jump+2
	;
inst_jump
	jmp $0000
	
normal	lda TONE1,x		; normal note
lookup	asl a
	tax
	lda freqs,x
	ldy freqs+1,x
	rts
	
blipp2	lda TONE1,x
	ldy NOTE1,x
	beq lookup
	lda #OFF
	bne lookup
	
blipp	lda TONE1,x
	ldy NOTE1,x
	beq lookup
	
	cpy #$02
	bcs blipp_off
	
	clc
	adc #$0C
	bne lookup
	
blipp_off
	lda #OFF
	bne lookup
	;
arp
	lda ARP_CNT		; load current arp counter
	clc
	adc #$01
arplen	cmp #$06		; auto reset every 6 frames (n1,n1,n2,n2,n3,n3)
	bne *+4
	lda #$00
	sta ARP_CNT
	lsr a
	tay
	lda arpeggio,y	; for channel 2 (self-mod)
	clc
	adc TONE1,x
	bne lookup
	
vib	lda NOTE1,x
	and #$07
	tay
	lda vibrato,y
	bmi vib_sub1		; for negatives, different handling
	sta vib2+1
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs+1,x		; pre-load high byte
	lda freqs,x		; add low byte
	clc			; 
vib2	adc #$01		;
	bcc vib3		; if carry is still clear, then we're done
	iny			; otherwise, increment high byte
vib3	rts
	;
vib_sub1
	and #$7F
	sta vib4+1
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs+1,x
	lda freqs,x
	sec
vib4	sbc #$01
	bcs vib5
	dey  
vib5	rts
	
bassdrum
	;lda #$40		; turn on noise bit
	;sta NOISE
	;
	lda NOTE1,x		; look up note freq
	asl a
	tax
	;
	lda bass_freq+1,x	; 16 bit add: add snare freq
	tay
	lda bass_freq,x
	rts
	
snare	
	lda #$40		; turn on noise bit
	sta NOISE
	;
	lda TONE1,x		; look up note freq
	asl a
	tay
	;
	lda NOTE1,x
	tax
	lda snare_freq,x	; 16 bit add: add snare freq
	clc        
	adc freqs,y       
	pha
	lda freqs+1,y
	tay
	pla
	rts
;[eof]