;
; LOD Player Version 2
;
; 1Cf2
; 1D8f
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

OFF	= $47
	
; COMMAND BYTES

END_MARK	= $FE
SET_VOLTAB	= $FF
SET_ARP		= $FD
CLICK		= $FC
VOL_UP		= $FB
SETINS		= $F0
SETLEN		= $40

; Constants
base_note = -2 ; shift to G0
C0	= base_note + 0
Ci0	= base_note + 1
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

;-----
          
	;ALIGN 256
PLAYER_FREQ_INIT
	jmp PLAYER_FREQ_INIT_ACTUAL
PLAYER
	jmp PLAYER_ACTUAL
	
PLAYER_FREQ_INIT_ACTUAL
	;         
	; *** Freq init
	;
	ldx #(Channel1 - OFS) & 255
	ldy #(Channel1 - OFS) >> 8
	stx PCH1_LO
	sty PCH1_HI
	;
	ldx #(Channel2 - OFS) & 255
	ldy #(Channel2 - OFS) >> 8
	stx PCH2_LO
	sty PCH2_HI
	;
	;ldx #(Channel3 - OFS) & 255
	;ldy #(Channel3 - OFS) >> 8
	;stx PCH3_LO
	;sty PCH3_HI
	;
	ldx #$FF
	stx VOLTAB_CNT1
	stx VOLTAB_CNT2
	inx       
	stx NOTE1
	stx NOTE2
	;stx NOTE3
	stx FX
	jsr res - OFS
	inx
	stx NOTELEN1
	stx NOTELEN2
	;stx NOTELEN3
	jsr res - OFS
	;inx		; x=2
	;jsr res - OFS
	;
	lda #9*0
	sta VOLUME
	;
	rts

res	ldy #$00
	db $2C
	
advance	ldy PCH1,x
	;      
	lda PCH1_LO,x
	sta PCH_TEMP
	lda PCH1_HI,x
	sta PCH_TEMP+1
	;
	lda (PCH_TEMP),y	; LO byte
	sta CH1_LO,x
	iny
	lda (PCH_TEMP),y	; HI byte
	beq res
	sta CH1_HI,x
	iny
	sty PCH1,x
	rts
	
	;
	;##################
	;

PLAYER_ACTUAL
	ldx #$01
	;
channel_loop
	inc NOTE1,x
	;
	lda NOTE1,x
	cmp NOTELEN1,x
	beq next_note
	jmp channel_loop_end-OFS
	;
next_note 
	lda CH1_LO,x
	sta CH_TEMP
	lda CH1_HI,x
	sta CH_TEMP+1
	;
	ldy #$FF
	sty VOLTAB_CNT1,x
	iny
	sty NOTE1,x		; reset note counter
	sty ARP_CNT1,x
	;   
	lda (CH_TEMP),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	bne pl_10
	;
	jsr advance - OFS
	bne next_note		; should never be zero
	;
pl_10	
;	cmp #SET_VOLTAB
;	bne pl_12
;	;
;	sta VOLTAB_CNT
;	;
;	lda (CH_TEMP),y		; get lo byte
;	iny
;	sta VOL_TAB - OFS+1
;	;
;	lda (CH_TEMP),y		; get byte
;	iny
;	;
;pl_12	
	cmp #SET_ARP		; instrument change?
	bne pl_13
	;
	lda (CH_TEMP),y		; get arp lo byte
	sta arp_ptr1+1
	iny
;	lda (CH_TEMP),y		; get arpeggio byte
;	and #$0F
;	sta arpeggio+1-OFS
;	;
;	lda (CH_TEMP),y		; get same byte again
;	lsr a
;	lsr a
;	lsr a
;	lsr a
;	sta arpeggio+2-OFS
;	beq arp2v
;	;
;	lda #$06
;	db $2C
;arp2v	lda #$04
;	sta arplen+1
;	;
;	iny
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_13	cmp #CLICK
	bne pl_14
	;
	lda $FF11
	ora #$80
	sta $FF11
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_14	cmp #VOL_UP
	bne pl_15
	;
	lda VOLUME
	beq vol_at_max
	;
	sec
	sbc #$09
	sta VOLUME
	;
vol_at_max
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_15	cmp #$FA
	bne pl_11
	;
	dec $FF19
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_11	cmp #SETINS		; instrument change?
	bcc pl_01
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE1,x   	; store instrument type
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_01	cmp #SETLEN		; set note length?
	bcc pl_02
	;
	;SEC			; we know carry is always set
	sbc #SETLEN
	sta NOTELEN1,x
	;
	lda (CH_TEMP),y
	iny
	;
pl_02	; - store note!
	;
	sta TONE1,x
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH1_LO,x
	sta CH1_LO,x
	bcc noi_1
	inc CH1_HI,x
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel_loop_end
	dex
	bmi pl_50
	jmp channel_loop-OFS
	;    
pl_50	
	;
	; --- SOUND PROCESSING
	;
PLAYER_SOUND
	lda #$20
	sta NOISE
	;
	;ldx #$02		; channel 3
	;jsr sound - OFS
	;;
	;cmp #$FE
	;bne do_ch2
	;
	ldx #$01		; channel 2
	jsr sound - OFS
	;
do_ch2	sta F1LO_store - OFS+1
	sty F1HI_store - OFS+1
	;
	ldx #$00		; channel 1
	jsr sound - OFS
	sta F2LO_store+1
	sty F2HI_store+1
	;
	; ---
	;
	ldy VOLTAB_CNT1
	iny
res_v1	lda vol_ch1 - OFS,y
	bpl noi_v1		; check for $FF
	and #$0F		; reached, so warp
	tay
	bpl res_v1		; always jump
noi_v1	sty VOLTAB_CNT1
	sta vol1+1
	;
	ldy VOLTAB_CNT2
	iny
res_v2	lda vol_ch2 - OFS,y
	bpl noi_v2		; check for $FF
	and #$0F		; reached, so warp
	tay
	bpl res_v2		; always jump
noi_v2	sty VOLTAB_CNT2
	;
	clc
vol1	adc #$00
	sta vol1+1
	adc VOLUME
	tay
	lda volume_map - OFS,y
	ora NOISE
	sta FF11_store+1
	;
	; ---
	;
;	lda FX
;	beq no_fx
;	;
;	jsr effect_handing
;	;
;no_fx	
F2LO_store
	lda #$00
	sta F2LO
F2HI_store
	lda #$00
	sta F2HI
	;
F1LO_store
	lda #$00
	sta F1LO
	lda F1HI
	and #$FC
F1HI_store
	ora #$00
	sta F1HI
	;
	lda F2LO
	cmp #$FE
	bne FF11_store
	lda F1LO
	cmp #$FE
	beq no_vol
	;
FF11_store
	lda #$00
	sta $FF11
	;
no_vol	rts     
	;
inst_table
	dw normal - OFS, bassdrum - OFS, snare - OFS, blipp - OFS, arp - OFS, vib - OFS
	;
sound	lda TONE1,x
	cmp #OFF
	beq lookup
	;
	lda INS_TYPE1,x
	asl a
	tay
	lda inst_table - OFS,y
	sta inst_jump - OFS+1
	lda inst_table - OFS+1,y
	sta inst_jump - OFS+2
	;
inst_jump
	jmp $0000
	
normal	lda TONE1,x		; normal note
lookup	asl a
	tax
	lda freqs,x
	ldy freqs+1,x
	rts
	
blipp2	lda TONE1,x
	ldy NOTE1,x
	beq lookup
	lda #OFF
	bne lookup
	
blipp	lda TONE1,x
	ldy NOTE1,x
	beq lookup
	
	cpy #$02
	bcs blipp_off
	
	clc
	adc #$0C
	bne lookup
	
blipp_off
	lda #OFF
	bne lookup
	;
	
arp
	ldy ARP_CNT1,x		; load current arp counter
	inc ARP_CNT1,x
	;
;	cpx #$00		; check which channel
;	beq arp_ptr1
;arp_ptr2
;	lda arpeggio,y		; for channel 2 (self-mod)
;	jmp arp_1
arp_ptr1
	lda arpeggio,y		; for channel 1 (self-mod)
;arp_1
	bpl arp_add		; check for negative numbers
	;
	and #$0F		; low byte is new position
	sta ARP_CNT1,x
	jmp arp			; again!
	;
arp_add
	clc
	adc TONE1,x
	jmp lookup
;arp
;	lda ARP_CNT		; load current arp counter
;	clc
;	adc #$01
;arplen	cmp #$06		; auto reset every 6 frames (n1,n1,n2,n2,n3,n3)
;	bne *+4
;	lda #$00
;	sta ARP_CNT
;	lsr a
;	tay
;	lda arpeggio - OFS,y	; for channel 2 (self-mod)
;	clc
;	adc TONE1,x
;	bne lookup
	
vib
	lda NOTE1,x
	and #$07
	tay
	lda vibrato-OFS,y
	bmi vib_sub1		; for negatives, different handling
	sta vib2-OFS+1
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs-OFS+1,x		; pre-load high byte
	lda freqs-OFS,x		; add low byte
	clc			; 
vib2	adc #$01		;
	bcc vib3		; if carry is still clear, then we're done
	iny			; otherwise, increment high byte
vib3	rts
	;
vib_sub1
	and #$7F
	sta vib4-OFS+1
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs-OFS+1,x
	lda freqs-OFS,x
	sec
vib4	sbc #$01
	bcs vib5
	dey  
vib5	rts
	
bassdrum
	;lda #$40		; turn on noise bit
	;sta NOISE
	;
	lda NOTE1,x		; look up note freq
	asl a
	tax
	;
	lda bass_freq+1 - OFS,x	; 16 bit add: add snare freq
	tay
	lda bass_freq - OFS,x
	rts
	
snare	
	lda #$40		; turn on noise bit
	sta NOISE
	;
	lda TONE1,x		; look up note freq
	asl a
	tay
	;
	lda NOTE1,x
	tax
	lda snare_freq - OFS,x	; 16 bit add: add snare freq
	clc        
	adc freqs,y       
	pha
	lda freqs+1,y
	tay
	pla
	rts
	
;effect_handing
;	and #$F0
;	cmp #$10
;	beq fx_1
;	;
;	; fx2
;	;  
;fx_2	lda FX
;	and #$0F
;	tax
;	cpx #(fx_2_lo-fx_2_hi)-1
;	bne fx2_not_over
;	;
;	lda #$00
;	beq fx_2a
;	;
;fx2_not_over
;	clc
;	adc #$21
;fx_2a	sta FX
;	;
;	lda fx_2_hi,x
;	tay
;	lda fx_2_lo,x
;	;
;fx_store
;	ldx F1LO_store+1
;	cpx #$FE
;	beq fx_f1
;	;
;	sta F2LO_store+1
;	sty F2HI_store+1
;	;
;	jmp fx_f2
;	; 
;fx_f1	sta F1LO_store+1
;	sty F1HI_store+1
;	;
;fx_f2	lda FF11_store+1
;	and #$F0
;	ora #$08
;	sta FF11_store+1
;	;
;	rts
;	
;fx_1	lda FX
;	and #$0F
;	tax
;	cpx #(fx_1_lo-fx_1_hi)-1
;	bne fx1_not_over
;	;
;	lda #$00
;	beq fx_1a
;	;
;fx1_not_over
;	clc
;	adc #$11
;fx_1a	sta FX
;	;
;	lda fx_1_hi,x
;	tay
;	lda fx_1_lo,x
;	;
;	jmp fx_store
;	
;fx_1_hi	db $03,$03,$02,$01
;fx_1_lo	db $A1,$42,$83,$06
;
;fx_2_hi	db $03,$03
;fx_2_lo	db $A1,$B9
;[eof]